Foxit PDF SDK

Public Types | Public Member Functions | List of all members
foxit::pdf::interform::FillerAssistCallback Class Referenceabstract

## Public Types
enum | PopupMenuItem { e_PopupMenuItemNone = 0, e_PopupMenuItemCut = 1, e_PopupMenuItemCopy = 2, e_PopupMenuItemPaste = 3, e_PopupMenuItemDelete = 4, e_PopupMenuItemSelectAll = 5 }
| Enumeration for popup menu item. More...

## Public Member Functions
virtual bool | AppendPopupMenuItem (const void *h_popup_menu, PopupMenuItem popup_menu_item, const wchar_t *default_string)=0
| A callback function which is triggered when need to append popup menu item to popup menu. More...
virtual void * | CreatePopupMenu ()=0
| A callback function which is triggered when need to create a popup menu. More...
virtual void | DestroyPopupMenu (const void *h_popup_menu)=0
| A callback function which is triggered when need to destroy popup menu. More...
virtual bool | EnablePopupMenuItem (const void *h_popup_menu, PopupMenuItem popup_menu_item, bool is_enabled)=0
| A callback function which is triggered when need to enable specified popup menu item in popup menu. More...
virtual void | FocusGotOnControl (const Control &control, const char *value)=0
| A callback function which is triggered when the focus is set to a form control. More...
virtual void | FocusLostFromControl (const Control &control, const char *value)=0
| A callback function which is triggered when the focus is lost from a form control. More...
virtual WString | GetClipboardText ()=0
| A callback function which is triggered when need to get the text on clipboard. More...
virtual int | GetVersion ()
| Get the version of derived implementation, for compatibility reason. More...
virtual bool | KillTimer (int timer_id)=0
| A callback function used to kill the timer event by timer identifier. More...
virtual void | Refresh (const PDFPage &page, const RectF *rect)=0
| A callback function used to refresh the specified area on a specified page. More...
virtual void | Release ()=0
| A callback function used to release current callback object itself. More...
virtual void | ReportInvalidValue (const wchar_t *form_field_name, const wchar_t *invalid_value)=0
| A callback function which is triggered when user entered an invalid value. More...
virtual void | SetClipboardText (const wchar_t *text)=0
| A callback function which is triggered when need to set clipboard text. More...
virtual bool | SetTimerCallback (int elapse, TimerCallback *timer, int *out_timer_id)=0
| A callback function used to set a system timer. More...
virtual bool | ShowPopupMenu (const void *h_popup_menu, const PointF &point)=0
| A callback function which is triggered when need to show popup menu. More...

## Detailed Description

This class represents a callback object to assist form filler. All the pure virtual functions in this class are used as callback functions and should be implemented by user.

## Member Enumeration Documentation

## ◆ PopupMenuItem

enum foxit::pdf::interform::FillerAssistCallback::PopupMenuItem

Enumeration for popup menu item.

Values of this enumeration should be used alone.

Enumerator
e_PopupMenuItemNone | No popup menu item.
e_PopupMenuItemCut | Popup menu item: "Cut".
e_PopupMenuItemCopy | Popup menu item: "Copy".
e_PopupMenuItemPaste | Popup menu item: "Paste".
e_PopupMenuItemDelete | Popup menu item: "Delete".
e_PopupMenuItemSelectAll | Popup menu item: "Select All".

## Member Function Documentation

## ◆ AppendPopupMenuItem()

virtual bool foxit::pdf::interform::FillerAssistCallback::AppendPopupMenuItem | ( | const void * | h_popup_menu,
|  | PopupMenuItem | popup_menu_item,
|  | const wchar_t * | default_string
| ) |  |
| pure virtual

A callback function which is triggered when need to append popup menu item to popup menu.

This callback function supports text field, combo box field.

Parameters

  [in] | h_popup_menu | Popup menu handle.
  [in] | popup_menu_item | A value to specify the exact popup menu item. Please refer to values starting from FillerAssistCallback::e_PopupMenuItemNone and this would be one of these values.
  [in] | default_string | Default string for the specified popup menu item.

Returns
  true means success, while false means failure.

## ◆ CreatePopupMenu()

virtual void* foxit::pdf::interform::FillerAssistCallback::CreatePopupMenu | ( |  | ) |
| pure virtual

A callback function which is triggered when need to create a popup menu.

This callback function supports text field, combo box field.

Returns
  Popup menu handle.

## ◆ DestroyPopupMenu()

virtual void foxit::pdf::interform::FillerAssistCallback::DestroyPopupMenu | ( | const void * | h_popup_menu | ) |
| pure virtual

A callback function which is triggered when need to destroy popup menu.

This callback function supports text field, combo box field.

Parameters

  [in] | h_popup_menu | Popup menu handle.

Returns
  None.

## ◆ EnablePopupMenuItem()

virtual bool foxit::pdf::interform::FillerAssistCallback::EnablePopupMenuItem | ( | const void * | h_popup_menu,
|  | PopupMenuItem | popup_menu_item,
|  | bool | is_enabled
| ) |  |
| pure virtual

A callback function which is triggered when need to enable specified popup menu item in popup menu.

This callback function supports text field, combo box field.

Parameters

  [in] | h_popup_menu | Popup menu handle.
  [in] | popup_menu_item | A value to specify the exact popup menu item. Please refer to values starting from FillerAssistCallback::e_PopupMenuItemNone and this would be one of these values.
  [in] | is_enabled | A boolean value to decide whether to enable the specified popup menu item or disable it.

Returns
  true means success, while false means failure.

## ◆ FocusGotOnControl()

virtual void foxit::pdf::interform::FillerAssistCallback::FocusGotOnControl | ( | const Control & | control,
|  | const char * | value
| ) |  |
| pure virtual

A callback function which is triggered when the focus is set to a form control.

This callback function supports text field, combo box field, list box field, push button field, check box field, radio button field.

Parameters

  [in] | control | The form control object to which the focus is set.
  [in] | value | The value of form field associated with the control. If the control belongs to a push button field, this value would always be an empty string.

Returns
  None.

## ◆ FocusLostFromControl()

virtual void foxit::pdf::interform::FillerAssistCallback::FocusLostFromControl | ( | const Control & | control,
|  | const char * | value
| ) |  |
| pure virtual

A callback function which is triggered when the focus is lost from a form control.

This callback function supports text field, combo box field, list box field, push button field, check box field, radio button field.

Parameters

  [in] | control | The form control object, from which the focus is lost.
  [in] | value | The value of form field associated with the control. If the control belongs to a push button field, this value would always be an empty string.

Returns
  None.

## ◆ GetClipboardText()

virtual WString foxit::pdf::interform::FillerAssistCallback::GetClipboardText | ( |  | ) |
| pure virtual

A callback function which is triggered when need to get the text on clipboard.

This callback function supports text field, combo box field.

Returns
  The text on clipboard.

## ◆ GetVersion()

virtual int foxit::pdf::interform::FillerAssistCallback::GetVersion | ( |  | ) |
| inline virtual

Get the version of derived implementation, for compatibility reason.

Returns
  Version of derived implementation.

## ◆ KillTimer()

virtual bool foxit::pdf::interform::FillerAssistCallback::KillTimer | ( | int | timer_id | ) |
| pure virtual

A callback function used to kill the timer event by timer identifier.

Parameters

  [in] | timer_id | The timer identifier returned by an earlier calling of callback function FillerAssistCallback::SetTimerCallback.

Returns
  true means success, while false means failure.

## ◆ Refresh()

virtual void foxit::pdf::interform::FillerAssistCallback::Refresh | ( | const PDFPage & | page,
|  | const RectF * | rect
| ) |  |
| pure virtual

A callback function used to refresh the specified area on a specified page.

Parameters

  [in] | page | A PDF page object.
  [in] | rect | A rectangle that specifies the area on the page to be redrawn. NULL means to refresh the whole page.

Returns
  None.

## ◆ Release()

virtual void foxit::pdf::interform::FillerAssistCallback::Release | ( |  | ) |
| pure virtual

A callback function used to release current callback object itself.

Returns
  None.

## ◆ ReportInvalidValue()

virtual void foxit::pdf::interform::FillerAssistCallback::ReportInvalidValue | ( | const wchar_t * | form_field_name,
|  | const wchar_t * | invalid_value
| ) |  |
| pure virtual

A callback function which is triggered when user entered an invalid value.

This callback function supports text field, combo box field.

Parameters

  [in] | form_field_name | The name of form field associated with the control.
  [in] | invalid_value | The invalid value of form field associated with the control.

Returns
  None.

## ◆ SetClipboardText()

virtual void foxit::pdf::interform::FillerAssistCallback::SetClipboardText | ( | const wchar_t * | text | ) |
| pure virtual

A callback function which is triggered when need to set clipboard text.

This callback function supports text field, combo box field.

Parameters

  [in] | text | The text need to be set to clipboard.

Returns
  None.

## ◆ SetTimerCallback()

virtual bool foxit::pdf::interform::FillerAssistCallback::SetTimerCallback | ( | int | elapse,
|  | TimerCallback * | timer,
|  | int * | out_timer_id
| ) |  |
| pure virtual

A callback function used to set a system timer.

This callback function is called to install a system timer. When a time-out value is specified, and every time when a time-out occurs, the system passes a message to the timer callback function.

Parameters

  [in] | elapse | Specifies the time-out value, in milliseconds.
  [in] | timer | A TimerCallback object as timer.
  [out] | out_timer_id | Output parameter that receives the timer identifier of the new timer if the function is finished successfully. This value would be passed to callback function FillerAssistCallback::KillTimer to kill the timer. Nonzero if the function is successful; otherwise, this should be zero.

Returns
  true means success, while false means failure.

## ◆ ShowPopupMenu()

virtual bool foxit::pdf::interform::FillerAssistCallback::ShowPopupMenu | ( | const void * | h_popup_menu,
|  | const PointF & | point
| ) |  |
| pure virtual

A callback function which is triggered when need to show popup menu.

This callback function supports text field, combo box field.

Parameters

  [in] | h_popup_menu | Popup menu handle.
  [in] | point | Left-top point used to locate where to show the popup menu, in PDF coordinate system.

Returns
  true means success, while false means failure.